package stx.libjava.stworkspace;

import java.io.BufferedReader;
import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import stx.libjava.ClassLoader;

/**
 *
 * @author Marcel Hlopko
 */
public class EvaluatorServlet extends HttpServlet {

    @Override
    protected void doPost(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        java.lang.ClassLoader smalltalkClassLoader = ClassLoader.getSmalltalkClassLoader();
        String code = "";
        BufferedReader reader = req.getReader();
        String line;
        while ((line = reader.readLine()) != null) {
            code += line;
        }
        try {
            Class<Evaluator> stCompiler = (Class<Evaluator>) smalltalkClassLoader.loadClass("ByteCodeCompiler");
            String result = stCompiler.newInstance().evaluate(code);
            resp.getWriter().print(result);
        } catch (ClassNotFoundException ex) {
            resp.getWriter().print("Cannot load ByteCodeCompiler - not found");
        } catch (InstantiationException e) {
            resp.getWriter().print("cannot instantiate ByteCodeCompiler: " + e);
        } catch (IllegalAccessException e) {
            resp.getWriter().print("cannot instantiate ByteCodeCompiler - illegal access ");
        } catch (UnsatisfiedLinkError e) {
            resp.getWriter().print("cannot load ByteCodeCompiler - link error ");
        }
    }
}
