<%-- 
    Document   : index
    Created on : Aug 21, 2012, 9:03:18 PM
    Author     : Marcel Hlopko
--%>

<%@page contentType="text/html" pageEncoding="UTF-8"%>
<!DOCTYPE html>
<html lang="en">
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
        <title>Smalltalk Workspace</title>
        <script src="//ajax.googleapis.com/ajax/libs/jquery/1.8.0/jquery.min.js"></script>        
        <link rel="stylesheet" href="//netdna.bootstrapcdn.com/twitter-bootstrap/2.1.0/css/bootstrap-combined.min.css"/>
        <script src="//netdna.bootstrapcdn.com/twitter-bootstrap/2.1.0/js/bootstrap.min.js"></script>
        <script type="text/javascript">
            $.fn.isBound = function(type, fn) {
                if (this.data('events') === undefined) {
                    return false;
                }
                var data = this.data('events')[type];

                if (data === undefined || data.length === 0) {
                    return false;
                }   
                return (-1 !== $.inArray(fn, data.map(function(o) {
                    return o.handler
                })));
            };

            $.fn.bindIfNotBound = function(eventName, handler) {
                this.each(function() {
                    if (!$(this).isBound(eventName, handler)) {        
                        $(this).bind(eventName, handler);
                    }
                });    
            };
            
            $(document).ready(function() {            
                $("#submit-button").click(function(e) {
                    e.preventDefault();
                    submitData();                                         
                });
                $("#input").focus();
            });
            
            function submitData() {
                $.ajax({
                    type: "POST",
                    url: "evaluate",
                    data: $("#input").val(),
                    contentType: 'application/json;charset=utf-8',
                    success: success,
                    error: error
                });
            }
            
            function prependNewOutputElement(text, element) {
                outputElement = '' +
                    '                       <div class="span8 well remove-output">' +
                    '                           <button class="close">&times;</button>' +
                    '                           <p>' + text + '</p>' +
                    '                       </div>';
                $(outputElement).hide().prependTo(element).fadeIn('slow');
                $(".remove-output").bindIfNotBound("click", function(e) {
                    e.preventDefault();
                    $(this).fadeOut('slow', function() {$(this).remove();});                    
                })
            }
            
            function success(result) {
                prependNewOutputElement(result, $("#output")); 
                $("#input").val('');
                $("#input").focus();
            }    
            
            function error() {
                prependNewOutputElement("Could not talk to the evaluator :(",$("#output"));
            }
        </script>
    </head>    
    <body>  
        <div class="row" style="margin-top: 30px">
            <div class="span8 offset2">
                <div class="span5">
                    <h1>Smalltalk Workspace</h1>
                </div>           
                <div class="span2">                    
                    <a id="logo" href="https://swing.fit.cvut.cz/projects/stx-libjava">
                        <img src="https://swing.fit.cvut.cz/projects/stx-libjava/chrome/site/javax_web_270x70.png" alt="STX:LIBJAVA" />
                    </a>
                </div>
            </div>
            <div class="span8 offset2">
                <p class="lead" style="text-align: justify">
                    Hello! I'm Smalltalk Workspace. Write some Smalltalk code 
                    and I will print the result. By the way, I am running as a Java web application
                    deployed on Tomcat. And this Tomcat is running on
                    <a href="https://swing.fit.cvut.cz/projects/stx-libjava/">STX:LIBJAVA</a>.
                    Pretty cool, huh? :)
                </p>
                <p>
                    STX:LIBJAVA is a tiny Java implementation allowing Java programs to run 
                    directly under 
                    <a href="http://www.exept.de/en/products/smalltalkx">Smalltalk/X VM</a>.                    
                </p>
            </div>            
            <div class="span9 offset2">
                <div class="row"> 
                    <div class="span8">
                        <textarea  rows="5" style="width: 100%; resize: none" id="input"></textarea>
                    </div>
                </div>
                <div class="row">
                    <div class="span2 offset6" >
                        <input type="submit" id="submit-button" class="span2 btn btn-primary" value="Evaluate!" />
                    </div>                            
                </div>            
                <div id="output" class="row" style="margin-top: 50px;">                    
                </div>
            </div>            
        </div>
    </body>
</html>
